#undef  fcryst
#define fcryst fcr.qw
extern freq_t fcr ;   //crystal frequency [MHz]*2^24fs
extern void SI570_Load(void);
#undef _2
#define _2(x) (1UL << x)
extern char SetFrequency(void);
extern unsigned long frequency;
extern unsigned char I2C_adr;


// *** WARNING *** All data used by the 'rewritable' (aka 'user') code must be separated
// into a separate segment using the USERDATA macro. This prevents new variables in the
// user code from relocating variables used by the code which is NOT rewritten.
// *** ALSO NOTE *** USERDATA variables are never initialised by the C startup code, so
// a declaration of the form "USERDATA int fred = 5;" does not have the expected effect -
// the value of fred at startup is undefined, and the "=5" part is silently ignored. USERDATA
// variable must be explicitly initialised before use.

USERDATA unsigned char debug_byte;
USERDATA signed char Si570_freq_mult;
USERDATA signed char Si570_freq_div;
USERDATA long Si570_freq_offset;
USERDATA unsigned long Si570_centre;				// Frequency for last full reprogram of the Si570
USERDATA uchar Si570_centre_regs[2];

extern unsigned char SI570_data[6];
extern unsigned char byte_adr;

void UpdateFCryst(void) REWRITABLE;
void UpdateFCryst(void){
uchar i;
if (eeprom_read_byte((uint8_t *)F_CRYST_STATUS)!=0xff) //  read calibrated crystal frequency if available
  {
	for (i=0;i<4;i++)
	   fcr.bytes[i]=eeprom_read_byte((uint8_t *)(i+F_CRYST)); //read f_cryst from EEPROM if available
  }
}

// Initialise 'USERDATA' vars - these are not automatically handled by the C startup code.
void InitVars(void) REWRITABLE;
void InitVars(void){
uchar   i;
debug_byte=0;
DDRB = PORTB_DDR;			//set which Port B pins are outputs
PORTB = PORTB_INIT;			//set outputs to initial state
byte_adr = 7;
fcryst=114.285*_2(19)*_2(5); 							//initialize fcryst to crystal frequency[MHz]*2^24
I2C_adr=0x55;
i = eeprom_read_byte((uint8_t *)I2C_ADR);
if (i!=0xFF) I2C_adr=i;
UpdateFCryst();
i = eeprom_read_byte((uint8_t *)INIT_SI570); 	//  read init status = I2C address for SI570
if (i!=0xff) I2C_adr = i;									//USB_SYNTH mode with remember frequency on startup	
frequency=0;
Si570_centre = 0;
Si570_freq_mult = DEF_FREQ_MULT;
Si570_freq_div = DEF_FREQ_DIV;
Si570_freq_offset = 0;
if (eeprom_read_byte((uint8_t *)(DEFD))==0) RecallFrequency(0); //restore last settings if available
freq.qw=frequency;
SetFrequency();
PCMSK |= (1<<PCINT5) | (1<<PCINT4); 	//  tell pin change mask to listen to pin1/PCINT5 and pin3/PCINT4
GIMSK |= (1<<PCIE); 	// enable PCINT interrupt in the general interrupt mask
TW_Action();
}

