extern uint16_t jump_table[];


extern unsigned long frequency;
extern freq_t freq;
extern char SetFreqAndDisplay(void);
extern signed char Si570_freq_mult;
extern signed char Si570_freq_div;
extern long Si570_freq_offset;

extern unsigned char SI570CalcRegs(void);
extern void SI570_Load_NoFreeze(void);
extern char SetFrequency(void);

void TCXO_Action(void) REWRITABLE;
void TCXO_Action(void){
#ifdef DEBUG_LEDS
i2c_debug_outbyte(dfcryst);
#endif
if (SI570CalcRegs()>0) SI570_Load_NoFreeze();
}

void RecallFrequency(char n) REWRITABLE;		//recall device state to EEPROM location n (0...15)
void RecallFrequency(char n){
n=n<<4;
unsigned char i = eeprom_read_byte((uint8_t *)(n+DEFD)); // check if valid info in EEPROM
if (i==0)
  {
   Si570_freq_mult = eeprom_read_byte((uint8_t *)(n+MUL));
   Si570_freq_div  = eeprom_read_byte((uint8_t *)(n+DIV));
   for (i=0;i<4;i++)
        {
		(*(ofs_t *)&Si570_freq_offset).bytes[i] = eeprom_read_byte((uint8_t *)(i+n+OFS)); //Read IF offset from EEPROM (4 bytes)
        (*(freq_t *)&frequency).bytes[i] = eeprom_read_byte((uint8_t *)(i+n+FREQ)); }


  }
}

void TW_Action(void) REWRITABLE;
void TW_Action(void){  
_delay_ms(100);
char d=(PINB & 0x30)>>4;	//get input states PB4=Q1 and PB5=Q2
d=d | (PINB & 4);			//get input state  PB2=Q4
d=d | ((PINB & 1)<<3);		//get input state  PB0=Q8
//if (usb_connected==0)i2c_debug_outbyte(d);	/* debug: check ports */
RecallFrequency(d); 		
freq.qw=frequency;
SetFrequency();
}


ISR(PCINT0_vect)
{
pt2TW_Action();
}



